'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _build = require('./build');

var _build2 = _interopRequireDefault(_build);

var _watch = require('../tasks/watch');

var _watch2 = _interopRequireDefault(_watch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function dev(config) {

  (0, _build2.default)(_extends({}, config, { dev: true })).then(function () {
    var client = config.client;
    var server = config.server;
    var common = config.common;
    var log = common.log;


    log.info('Dev server');

    if (server) {

      require('../tasks/nodemon')(_extends({
        src: server.dest }, common, {
        watch: [server.dest].concat(client ? [client.dest + '/index.html'] : [])
      }));
    } else {

      require('../tasks/static')(_extends({
        src: client.dest }, common));
    }

    (0, _watch2.default)(config);
  });
};