'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _logger = require('./utils/logger');

var _logger2 = _interopRequireDefault(_logger);

var _findPaths = require('./utils/findPaths');

var _findPaths2 = _interopRequireDefault(_findPaths);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var options = (0, _minimist2.default)(process.argv.slice(2));
var args = options._;

// ------------ Command ------------

var allowedCommands = ['dev', 'build'];
var command = args[0];

if (command && allowedCommands.indexOf(command) >= 0) {
  args.shift();
} else command = 'dev';

// ------------ Config ------------

var root = process.cwd();
var src = args[0] ? args[0] : root;

var paths = (0, _findPaths2.default)({ root: root, src: src });
var log = (0, _logger2.default)({ verbose: !options.quiet });
var relative = function relative(name) {
  return _path2.default.relative(paths.src, name);
};

var config = _extends({}, paths, {
  common: {
    root: root,
    dev: command === 'dev',
    log: log,
    relative: relative
  }
});

log.info('Command');
log(command, paths.src);

if (paths.client || paths.server) {
  require('./commands/' + command)(config);
} else {
  log.error('No client or server found');
}