'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildServer;

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpBabel = require('gulp-babel');

var _gulpBabel2 = _interopRequireDefault(_gulpBabel);

var _babel = require('../babel.config');

var _babel2 = _interopRequireDefault(_babel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildServer(config) {
  var src = config.src;
  var dest = config.dest;
  var log = config.log;
  var relative = config.relative;
  var watching = config.watching;


  return new Promise(function (resolve, reject) {

    _gulp2.default.src(src + '/**/*.js').pipe((0, _gulpBabel2.default)(_babel2.default)).on('error', function (e) {
      log.error('Server', e.message);
      this.emit('end');
    }).pipe(_gulp2.default.dest(dest)).on('end', function () {
      !watching && log('Server', relative(src) + ' -> ' + relative(dest));
      resolve();
    });
  });
}