'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = css;

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpRename = require('gulp-rename');

var _gulpRename2 = _interopRequireDefault(_gulpRename);

var _gulpSass = require('gulp-sass');

var _gulpSass2 = _interopRequireDefault(_gulpSass);

var _gulpSourcemaps = require('gulp-sourcemaps');

var _gulpSourcemaps2 = _interopRequireDefault(_gulpSourcemaps);

var _gulpCleanCss = require('gulp-clean-css');

var _gulpCleanCss2 = _interopRequireDefault(_gulpCleanCss);

var _gulpAutoprefixer = require('gulp-autoprefixer');

var _gulpAutoprefixer2 = _interopRequireDefault(_gulpAutoprefixer);

var _gulpIf = require('gulp-if');

var _gulpIf2 = _interopRequireDefault(_gulpIf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function css(config) {
  var root = config.root;
  var src = config.src;
  var dest = config.dest;
  var _config$dev = config.dev;
  var dev = _config$dev === undefined ? true : _config$dev;
  var _config$name = config.name;
  var name = _config$name === undefined ? 'app.css' : _config$name;
  var log = config.log;
  var relative = config.relative;
  var watching = config.watching;


  return new Promise(function (resolve, reject) {

    _gulp2.default.src(src + '/index.scss').pipe((0, _gulpIf2.default)(dev, _gulpSourcemaps2.default.init())).pipe((0, _gulpSass2.default)({
      keepSpecialComments: false,
      // Resolve require paths for client and shared lib
      includePaths: [src + '/lib', root + '/shared'],
      //relativeTo: './app',
      processImport: false // ?
    })).on('error', function (e) {
      log.error('CSS', e.message);
      this.emit('end');
    }).pipe((0, _gulpAutoprefixer2.default)({ browsers: ['last 2 versions', 'IE 10', '> 1%'], cascade: false })).pipe((0, _gulpIf2.default)(!dev, (0, _gulpCleanCss2.default)())).pipe((0, _gulpRename2.default)(name)).pipe((0, _gulpIf2.default)(dev, _gulpSourcemaps2.default.write())).pipe(_gulp2.default.dest(dest)).on('end', function () {
      !watching && log('CSS', relative(src) + '/index.scss -> ' + relative(dest) + '/' + name);
      resolve();
    });
  });
}