'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = html;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpIf = require('gulp-if');

var _gulpIf2 = _interopRequireDefault(_gulpIf);

var _gulpEjs = require('gulp-ejs');

var _gulpEjs2 = _interopRequireDefault(_gulpEjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function html(_ref) {
  var src = _ref.src;
  var dest = _ref.dest;
  var _ref$dev = _ref.dev;
  var dev = _ref$dev === undefined ? true : _ref$dev;
  var log = _ref.log;
  var relative = _ref.relative;
  var watching = _ref.watching;
  var _ref$electron = _ref.electron;
  var electron = _ref$electron === undefined ? false : _ref$electron;


  var script = injectScript({ electron: electron, dev: dev });

  return new Promise(function (resolve, reject) {
    _gulp2.default.src(src + '/index.html').pipe((0, _gulpEjs2.default)({ script: script }, { ext: '.html' })).pipe(_gulp2.default.dest(dest)).on('end', function () {
      !watching && log('HTML', relative(src) + '/index.html -> ' + relative(dest) + '/index.html');
      resolve();
    });
  });
}

function injectScript(_ref2) {
  var electron = _ref2.electron;
  var dev = _ref2.dev;


  var script = null;

  if (electron) {

    script = '<script>electron = require(\'electron\');' + (dev ? 'require(process.cwd()+\'/electron-connect\').client.create()' : '') + '</script>';
  } else if (dev) {

    var liveReloadClient = _fs2.default.readFileSync(_path2.default.join(__dirname, 'live-reload/client.js'), 'utf-8');

    script = '<script>' + liveReloadClient + '</script>';
  }

  return script;
}