'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = js;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _gulp = require('gulp');

var _gulp2 = _interopRequireDefault(_gulp);

var _gulpBro = require('gulp-bro');

var _gulpBro2 = _interopRequireDefault(_gulpBro);

var _gulpRename = require('gulp-rename');

var _gulpRename2 = _interopRequireDefault(_gulpRename);

var _babelify = require('babelify');

var _babelify2 = _interopRequireDefault(_babelify);

var _gulpUglify = require('gulp-uglify');

var _gulpUglify2 = _interopRequireDefault(_gulpUglify);

var _gulpIf = require('gulp-if');

var _gulpIf2 = _interopRequireDefault(_gulpIf);

var _gulpSourcemaps = require('gulp-sourcemaps');

var _gulpSourcemaps2 = _interopRequireDefault(_gulpSourcemaps);

var _babel = require('../babel.config');

var _babel2 = _interopRequireDefault(_babel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function js(_ref) {
  var src = _ref.src;
  var dest = _ref.dest;
  var _ref$name = _ref.name;
  var name = _ref$name === undefined ? 'app.js' : _ref$name;
  var root = _ref.root;
  var _ref$dev = _ref.dev;
  var dev = _ref$dev === undefined ? true : _ref$dev;
  var log = _ref.log;
  var relative = _ref.relative;
  var watching = _ref.watching;


  return new Promise(function (resolve, reject) {

    _gulp2.default.src(src + '/index.js', { read: false }) // recommended option for gulp-bro
    .pipe((0, _gulpBro2.default)({
      entries: [src],
      debug: dev, // Source maps
      transform: [_babelify2.default.configure(_babel2.default)],
      // Resolve require paths for client and shared lib
      paths: [src + '/lib', root + '/shared']
    })).pipe((0, _gulpIf2.default)(!dev, (0, _gulpUglify2.default)())).pipe((0, _gulpRename2.default)(name)).pipe(_gulp2.default.dest(dest)).on('error', function (e) {
      /*eslint-disable no-console*/
      log.error('JS', e.message);
      this.emit('end');
    }).on('end', function () {
      !watching && log('JS', relative(src) + '/index.js -> ' + relative(dest) + '/' + name);
      resolve();
    });
  });
}