'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = liveReloadServer;
exports.reload = reload;
exports.reloadCSS = reloadCSS;

var _ws = require('ws');

var _ws2 = _interopRequireDefault(_ws);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var port = 35729; // Must be the same in client.js
var server = void 0;
var logger = void 0;

function liveReloadServer(_ref) {
  var log = _ref.log;


  server = new _ws2.default.Server({ port: port });
  logger = log;

  log('Live reload', 'Server at port ' + port);

  return { reload: reload, reloadCSS: reloadCSS };
}

function reload() {
  //logger && logger('Live reload', 'Reload page')
  server && server.clients.forEach(function (client) {
    client.send(JSON.stringify({ reload: true }));
  });
}

function reloadCSS() {
  //logger && logger('Live reload', 'Reload CSS')
  server && server.clients.forEach(function (client) {
    client.send(JSON.stringify({ reloadCSS: true }));
  });
}