'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = startWatch;

var _gulpWatch = require('gulp-watch');

var _gulpWatch2 = _interopRequireDefault(_gulpWatch);

var _js = require('./js');

var _js2 = _interopRequireDefault(_js);

var _css = require('./css');

var _css2 = _interopRequireDefault(_css);

var _html = require('./html');

var _html2 = _interopRequireDefault(_html);

var _assets = require('./watch/assets');

var _assets2 = _interopRequireDefault(_assets);

var _server = require('./live-reload/server');

var _server2 = _interopRequireDefault(_server);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function startWatch(_ref) {
  var client = _ref.client;
  var server = _ref.server;
  var assets = _ref.assets;
  var common = _ref.common;
  var root = common.root;
  var log = common.log;


  common.watching = true;

  if (client) {
    (function () {
      var _liveReloadServer = (0, _server2.default)({ log: log });

      var reload = _liveReloadServer.reload;
      var reloadCSS = _liveReloadServer.reloadCSS;

      var shared = root + '/shared';

      (0, _gulpWatch2.default)([client.src + '/**/*.js', shared + '/**/*.js'], function () {
        (0, _js2.default)(_extends({}, client, common)).then(reload);
      });

      (0, _gulpWatch2.default)([client.src + '/**/*.scss', shared + '/**/*.scss'], function () {
        (0, _css2.default)(_extends({}, client, common)).then(reloadCSS);
      });

      (0, _gulpWatch2.default)(client.src + '/**/*.html', function () {
        (0, _html2.default)(_extends({}, client, common)).then(server ? require('./watch/reloadAfterNodemon') : reload);
      });

      (0, _assets2.default)(_extends({}, assets, common));
    })();
  }

  if (server) {
    require('./watch/server')(_extends({}, server, common));
  }

  log('Watch', (client ? 'client' + (server ? ' and ' : '') : '') + (server ? 'server' : ''));
}