'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = findPaths;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fileExists = require('./fileExists');

var _fileExists2 = _interopRequireDefault(_fileExists);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findPaths(_ref) {
  var root = _ref.root;
  var src = _ref.src;


  var paths = findPathsFrom(src);

  if (!paths.client && !paths.server && src !== root) {
    src = _path2.default.join(root, 'projects', src);
    paths = findPathsFrom(src);
  }

  return _extends({ root: root, src: src }, paths);
}

function findPathsFrom(src) {

  var dest = _path2.default.join(src, 'build');

  var client = {
    src: _path2.default.join(src, 'client'),
    dest: _path2.default.join(dest, 'client')
  };

  var server = {
    src: _path2.default.join(src, 'server'),
    dest: _path2.default.join(dest, 'server')
  };

  var assets = {
    src: _path2.default.join(src, 'assets'),
    dest: client.dest
  };

  if (!(0, _fileExists2.default)(client.src)) client = false;
  if (!(0, _fileExists2.default)(server.src)) server = false;

  return { client: client, server: server, assets: assets };
}