'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createLogger;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createLogger(options) {

  var log = function log(name) {
    var _console;

    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    options.verbose && (_console = console).log.apply(_console, [_chalk2.default.blue('  ' + name) + ':'].concat(args));
  };

  log.info = function (name) {
    var _console2;

    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    options.verbose && (_console2 = console).log.apply(_console2, [_chalk2.default.green(name) + ':'].concat(args));
  };

  log.error = function (name) {
    var _console3;

    for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
      args[_key3 - 1] = arguments[_key3];
    }

    console.error(_chalk2.default.red(name));
    if (args.length) (_console3 = console).log.apply(_console3, args);
  };

  return log;
}